package gui;
/**
 * 
 * @author Sebastian & Stefan
 * @version 0.5
 */
import imageintegrity.*;
import javax.sound.sampled.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import javax.swing.filechooser.FileFilter;

public class MD5Gui extends JFrame implements ActionListener{

	/**
	 * 
	 */
	private static final long serialVersionUID = -5261981244797199654L;
	private ShowPics picSmile, picJpg; 
	private JTextField tkeyBild,tkeyInput;
	private JButton bTest,bInput,bExit,bMD5generate,bcheck;
	private JPanel pBild,pButtons,pTfields,pMsg;
	private JPasswordField pfield;
	private IMD5Image image;
	private static Clip clip;
	private static String[] soundGood = {"dodawd.wav", "elephant_1.wav", "holabig.wav", "woohoo.wav", "kideeey.wav"};
	private static String[] soundBad  = {"babylau.wav", "boo.wav", "joker.wav", "yayaya.wav", "oops.wav"};
	
	public MD5Gui(){
		super("Gui Fenster");
		Container cp = getContentPane();
		cp.setLayout(null);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setJMenuBar(createJMenuBar());
		
		image = null;
		bTest = new JButton("Prfen");
		bInput = new JButton("Einfgen");
		bExit = new JButton("Beenden");
		
		pBild = new JPanel(new GridLayout(1,1));
		pButtons = new JPanel(new FlowLayout(FlowLayout.CENTER,10,10));
		pMsg = new JPanel(new GridLayout(1,1));
		pTfields =new JPanel(new FlowLayout(FlowLayout.CENTER,15,10));
		
		pBild.setBounds(5, 5, 400, 400);
		pBild.setBorder(new TitledBorder("Bild"));
		pTfields.setBounds(420, 5, 365, 200);
		pTfields.setBorder(new TitledBorder("Bilddaten"));
		pButtons.setBounds(5, 410, 400, 100);
		pButtons.setBorder(new TitledBorder("Buttons"));
		pMsg.setBounds(420, 210, 365, 300);
		pMsg.setBorder(new TitledBorder("Nachricht"));
		//pMsg.setEditable(false);
		//pMsg.setText("???   Bitte ein Bild auswhlen");
		
		pButtons.add(bTest);
		pButtons.add(bInput);
		pButtons.add(bExit);
		
		
		pTfields.add(new JLabel("MD5 Bildschlssel"));
		pTfields.add(tkeyBild = new JTextField(30));
		tkeyBild.setEditable(false);
		pTfields.add(new JLabel("Berechneter MD5 Hashwert "));
		pTfields.add(tkeyInput = new JTextField(30));
		tkeyInput.setEditable(false);
		
		
		
		cp.add(pBild);
		cp.add(pTfields);
		cp.add(pButtons);
		cp.add(pMsg);
		
		pBild.add(picJpg = new ShowPics());
		pMsg.add(picSmile = new ShowPics());
		
		setSize(800,600);
		setVisible(true);
		
		
		bTest.addActionListener(this);
		bTest.setActionCommand("bt");
		bInput.addActionListener(this);
		bInput.setActionCommand("bin");
		bExit.addActionListener(this);
		bExit.setActionCommand("exit");
		bcheck = new JButton("MD5 prfen");
		bMD5generate = new JButton("MD5 generieren");
		bcheck.addActionListener(this);
		bcheck.setActionCommand("chk");
		bMD5generate.addActionListener(this);
		bMD5generate.setActionCommand("MD5gen");
		
	}
	
	
	private JMenuBar createJMenuBar(){
		JMenuBar mbar=new JMenuBar();
		JMenu mDatei = new JMenu("Datei");
		JMenuItem itemOpen,itemEnd; 
		
		mDatei.setMnemonic('D');
		itemOpen= new JMenuItem("ffnen",'f');
		itemOpen.addActionListener(this);
		itemOpen.setActionCommand("Open");
		mDatei.add(itemOpen);
		mDatei.addSeparator();
		
		itemEnd = new JMenuItem("Beenden",'e');
		itemEnd.addActionListener(this);
		itemEnd.setActionCommand("close");
		mDatei.add(itemEnd);
		mbar.add(mDatei);
		
		return mbar;
	}
	
	
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable(){
			public void run(){	
				new MD5Gui();
			}});
	
	}
	
	
	public void actionPerformed(ActionEvent e) {
		String cmd = e.getActionCommand();
		
		
		if(cmd=="Open"){
			JFileChooser fc=new JFileChooser();
			fc.setFileFilter( new FileFilter()
					    {
					      public boolean accept( File f ) {
					    	  return f.isDirectory() ||
					    	  f.getName().toLowerCase().endsWith( ".jpeg")||
					    	  f.getName().toLowerCase().endsWith(".jpg");
					        	
					      }
					      public String getDescription(){
					    	  return "*.jpeg;*.jpg";
					      }}
			 );
			
			int returnVal = fc.showOpenDialog( null );
			
			if(returnVal == JFileChooser.APPROVE_OPTION)
		    {
		      File file = fc.getSelectedFile();
		      IMD5Image image=null;
		      picJpg.setImage(file,pBild);
		      try{
		    	String comment;  
		      	
		      	image = new MD5Jpeg(file.getAbsolutePath());
		    	comment = image.getComment();  
		      	
		    	if(comment != null && comment.length() == 32)  
		    	  tkeyBild.setText(comment);
		    	 else tkeyBild.setText("Bild enthlt keinen Hashwert");
		    	
		      }catch(IOException io ){
		    	  JOptionPane.showMessageDialog(this, io.getMessage(), "Fehler" ,JOptionPane.ERROR_MESSAGE);}
		      
		      
		      this.image = image;
		      this.tkeyInput.setText("");
		      //this.pMsg.setText("+++   Bild geladen:  \"" + file.getName() + "\"");
		    }
			
		}
		else if(cmd=="close"){
			System.exit(0);
		}
		else if(cmd == "exit"){
			System.exit(0);
		}
		else if(cmd == "bt"){
			JDialog d1;

			if(image == null) {
				JOptionPane.showMessageDialog(this, "Kein Bild geladen", "Fehler" ,JOptionPane.ERROR_MESSAGE);
				return;
			}

			d1 = new JDialog();
			
			d1.setLayout(new FlowLayout(FlowLayout.CENTER,10,10));
			pfield = new JPasswordField(20);
			pfield.setEchoChar('*');
			d1.add(new JLabel("MD5Hash prfen"));
			d1.add(bcheck);
			d1.add(new JLabel("Passwort: "));
			d1.add(pfield);
			d1.setLocation(200,200);
			d1.pack();
			d1.setModal(true);
			d1.setVisible(true);
			
		}else if(cmd=="chk"){
		   JPanel parent = (JPanel)((JButton)e.getSource()).getParent();
		   
		   try {
		   		String digest = image.createDigest(new String(pfield.getPassword()));
		   		
		   		tkeyInput.setText(digest);
		   		if(digest.equals(tkeyBild.getText())) {
		   			//pMsg.setText("+++   bereinstimmung der Hashwerte");
		   		    picSmile.setImage(new File("pics/e.jpg"),pMsg);

		   		    try {
		   		    	int rand = (int)(Math.random()*(double)soundGood.length);
		   		    	MD5Gui.playSampleFile("sounds/good/" + soundGood[rand], 0f, 0f);
		   			} catch(Exception ex) { /* Nichts */ ex.printStackTrace(); }
		   		}

		   		    
		   		
		   		else {//pMsg.setText("\n\n!!!   Achtung: keine bereinstimmung");
		   			picSmile.setImage(new File("pics/m.jpg"),pMsg);
		   			try {
		   				int rand = (int)(Math.random()*(double)soundBad.length);
		   				MD5Gui.playSampleFile("sounds/bad/" + soundBad[rand], 0f, 0f);
		   			} catch(Exception ex) { /* Nichts */ ex.printStackTrace(); }

		   		}
		   			
		   		
		   		} catch (IOException io) {
				JOptionPane.showMessageDialog(parent, io.getMessage(), "Fehler" ,JOptionPane.ERROR_MESSAGE);	
			  }
		   
		   	pMsg.repaint();
		   		
		   ((JDialog)parent.getTopLevelAncestor()).setVisible(false);
		   ((JDialog)parent.getTopLevelAncestor()).dispose();
		}
		else if(cmd=="bin"){
			JDialog d2;

			if(image == null) {
				JOptionPane.showMessageDialog(this, "Kein Bild geladen", "Fehler" ,JOptionPane.ERROR_MESSAGE);
				return;
			}
			
			d2 = new JDialog();
			d2.setLayout(new FlowLayout(FlowLayout.CENTER,10,10));
			pfield = new JPasswordField(20);
			pfield.setEchoChar('*');
			d2.add(new JLabel("MD5Hash berechnen"));
			d2.add(bMD5generate);
			d2.add(new JLabel("Passwort: "));
			d2.add(pfield);
			d2.setLocation(200,200);
			d2.pack();
			d2.setModal(true);
			d2.setVisible(true);
		}	
			else if(cmd=="MD5gen"){
				JPanel parent = (JPanel)((JButton)e.getSource()).getParent();
				
				try {
					int choice;
					String digest, comment;
					boolean overwrite=true;

					digest = image.createDigest(new String(pfield.getPassword()));
					
					if((comment=image.getComment()) != null) {
						choice = JOptionPane.showConfirmDialog(parent, "Vorhandenen Kommentar lschen?\n\n" + comment, "Kommentar lschen" , JOptionPane.YES_NO_OPTION, JOptionPane.INFORMATION_MESSAGE);
						
						if(choice != 0)
							overwrite = false;
					}
					
					if(overwrite) {
						image.setDigest(digest, true);
						tkeyBild.setText(digest);
						tkeyInput.setText("");
					}
				} catch (IOException io) {
					JOptionPane.showMessageDialog(parent, io.getMessage(), "Fehler" ,JOptionPane.ERROR_MESSAGE);	
				  }
	
			   ((JDialog)parent.getTopLevelAncestor()).setVisible(false);
			   ((JDialog)parent.getTopLevelAncestor()).dispose();
	
		   }
		}
	
	private static void playSampleFile(String name, float pan, float gain)
	  throws Exception
	  {
	    //AudioInputStream ffnen
	    AudioInputStream ais = AudioSystem.getAudioInputStream(
	      new File(name)
	    );
	    AudioFormat format = ais.getFormat();
	    //ALAW/ULAW samples in PCM konvertieren
	    if ((format.getEncoding() == AudioFormat.Encoding.ULAW) ||
	        (format.getEncoding() == AudioFormat.Encoding.ALAW))
	    {
	      AudioFormat tmp = new AudioFormat(
	        AudioFormat.Encoding.PCM_SIGNED,
	        format.getSampleRate(),
	        format.getSampleSizeInBits() * 2,
	        format.getChannels(),
	        format.getFrameSize() * 2,
	        format.getFrameRate(),
	        true
	      );
	      ais = AudioSystem.getAudioInputStream(tmp, ais);
	      format = tmp;
	    }
	    //Clip erzeugen und ffnen
	    DataLine.Info info = new DataLine.Info(
	      Clip.class,
	      format,
	      ((int) ais.getFrameLength() * format.getFrameSize())
	    );
	    Clip clip = (Clip)AudioSystem.getLine(info); 
	    clip.open(ais);
	    //PAN einstellen
	 //   FloatControl panControl = (FloatControl)clip.getControl(
	 //     FloatControl.Type.MASTER_GAIN
	 //   );
	 //   panControl.setValue(pan);
	    //MASTER_GAIN einstellen
	    FloatControl gainControl = (FloatControl)clip.getControl(
	      FloatControl.Type.MASTER_GAIN
	    );
	    gainControl.setValue(gain);
	    //Clip abspielen
	    clip.start(); 
	    while (true) {
	      try {
	        Thread.sleep(100);
	      } catch (Exception e) {
	        //nothing
	      }
	      if (!clip.isRunning()) {
	        break;
	      }
	    }
	    clip.stop();
	    clip.close();
	  }
	}
	
