/*
 * Created on 21.11.2005
 *
 */
package imageintegrity;

import java.io.*;

/**
 */
public class MD5 {
	private int A, B, C, D, AA, BB, CC, DD;
	private long currLen;
	private int[] X;
	private byte[] rest;
	
	public MD5() {
		X = new int[16];
	}
	
	public void init() {
		A = 0x67452301;
		B = 0xefcdab89;
		C = 0x98badcfe;
		D = 0x10325476;
		
		rest = new byte[0];
	}
	
	public void update(byte[] data) throws IOException {
		DataInputStream sin = new DataInputStream(new java.io.ByteArrayInputStream(data));
		byte[] input = new byte[data.length + rest.length];
		int blocks = input.length / 512, restLen = input.length % 512;
        
		//System.arraycopy(rest, 0, input, 0, restLen);
		//System.arraycopy(data, 0, input, restLen, data.length);
		blocks = 1;
		
		for(int i=0; i<blocks; i++) {
			X[0] = 0x80000000;
			
			for(int j=1; j<16; j++)
				X[j] = 0; //sin.readInt();

			AA = A;
			BB = B;
			CC = C;
			DD = D;
			
			/* --------------------------------------------------------------- */
			/* --------------------------- Runde 1 --------------------------- */
			/* --------------------------------------------------------------- */
			A = FF(A,B,C,D, X[0],  7, 0xd76aa478);
			D = FF(D,A,B,C, X[1], 12, 0xe8c7b756);
			C = FF(C,D,A,B, X[2], 17, 0x242070db);
			B = FF(B,C,D,A, X[3], 22, 0xc1bdceee);

			A = FF(A,B,C,D, X[4],  7, 0xf57c0faf);
			D = FF(D,A,B,C, X[5], 12, 0x4787c62a);
			C = FF(C,D,A,B, X[6], 17, 0xa8304613);
			B = FF(B,C,D,A, X[7], 22, 0xfd469501);

			A = FF(A,B,C,D, X[8],   7, 0x698098d8);
			D = FF(D,A,B,C, X[9],  12, 0x8b44f7af);
			C = FF(C,D,A,B, X[10], 17, 0xffff5bb1);
			B = FF(B,C,D,A, X[11], 22, 0x895cd7be);

			A = FF(A,B,C,D, X[12],  7, 0x6b901122);
			D = FF(D,A,B,C, X[13], 12, 0xfd987193);
			C = FF(C,D,A,B, X[14], 17, 0xa679438e);
			B = FF(B,C,D,A, X[15], 22, 0x49b40821);
			

			/* --------------------------------------------------------------- */
			/* --------------------------- Runde 2 --------------------------- */
			/* --------------------------------------------------------------- */
			A = GG(A,B,C,D, X[1],   5, 0xf61e2562);
			D = GG(D,A,B,C, X[6],   9, 0xc040b340);
			C = GG(C,D,A,B, X[11], 14, 0x265e5a51);
			B = GG(B,C,D,A, X[0],  20, 0xe9b6c7aa);

			A = GG(A,B,C,D, X[5],   5, 0xd62f105d);
			D = GG(D,A,B,C, X[10],  9,  0x2441453);
			C = GG(C,D,A,B, X[15], 14, 0xd8a1e681);
			B = GG(B,C,D,A, X[4],  20, 0xe7d3fbc8);

			A = GG(A,B,C,D, X[9],   5, 0x21e1cde6);
			D = GG(D,A,B,C, X[14],  9, 0xc33707d6);
			C = GG(C,D,A,B, X[3],  14, 0xf4d50d87);
			B = GG(B,C,D,A, X[8],  20, 0x455a14ed);

			A = GG(A,B,C,D, X[13],   5, 0xa9e3e905);
			D = GG(D,A,B,C, X[2],    9, 0xfcefa3f8);
			C = GG(C,D,A,B, X[7],   14, 0x676f02d9);
			B = GG(B,C,D,A, X[12],  20, 0x8d2a4c8a);

			/* --------------------------------------------------------------- */
			/* --------------------------- Runde 3 --------------------------- */
			/* --------------------------------------------------------------- */
			A = HH( A, B, C, D, X[ 5],  4, 0xfffa3942);
	        D = HH( D, A, B, C, X[ 8], 11, 0x8771f681);
	        C = HH( C, D, A, B, X[11], 16, 0x6d9d6122);
	        B = HH( B, C, D, A, X[14], 23, 0xfde5380c);
	        A = HH( A, B, C, D, X[ 1],  4, 0xa4beea44);
	        D = HH( D, A, B, C, X[ 4], 11, 0x4bdecfa9);
	        C = HH( C, D, A, B, X[ 7], 16, 0xf6bb4b60);
	        B = HH( B, C, D, A, X[10], 23, 0xbebfbc70);
	        A = HH( A, B, C, D, X[13],  4, 0x289b7ec6);
	        D = HH( D, A, B, C, X[ 0], 11, 0xeaa127fa);
	        C = HH( C, D, A, B, X[ 3], 16, 0xd4ef3085);
	        B = HH( B, C, D, A, X[ 6], 23,  0x4881d05);
	        A = HH( A, B, C, D, X[ 9],  4, 0xd9d4d039);
	        D = HH( D, A, B, C, X[12], 11, 0xe6db99e5);
	        C = HH( C, D, A, B, X[15], 16, 0x1fa27cf8);
	        B = HH( B, C, D, A, X[ 2], 23, 0xc4ac5665);

			/* --------------------------------------------------------------- */
			/* --------------------------- Runde 4 --------------------------- */
			/* --------------------------------------------------------------- */
	        A = II( A, B, C, D, X[ 0],  6, 0xf4292244);
	        D = II( D, A, B, C, X[ 7], 10, 0x432aff97);
	        C = II( C, D, A, B, X[14], 15, 0xab9423a7);
	        B = II( B, C, D, A, X[ 5], 21, 0xfc93a039);
	        A = II( A, B, C, D, X[12],  6, 0x655b59c3);
	        D = II( D, A, B, C, X[ 3], 10, 0x8f0ccc92);
	        C = II( C, D, A, B, X[10], 15, 0xffeff47d);
	        B = II( B, C, D, A, X[ 1], 21, 0x85845dd1);
	        A = II( A, B, C, D, X[ 8],  6, 0x6fa87e4f);
	        D = II( D, A, B, C, X[15], 10, 0xfe2ce6e0);
	        C = II( C, D, A, B, X[ 6], 15, 0xa3014314);
	        B = II( B, C, D, A, X[13], 21, 0x4e0811a1);
	        A = II( A, B, C, D, X[ 4],  6, 0xf7537e82);
	        D = II( D, A, B, C, X[11], 10, 0xbd3af235);
	        C = II( C, D, A, B, X[ 2], 15, 0x2ad7d2bb);
	        B = II( B, C, D, A, X[ 9], 21, 0xeb86d391);
	        
	        A += AA;
	        B += BB;
	        C += CC;
	        D += DD;
		}
	}
	
	public String finish() {
		int regs[] = {A, B, C, D}, x;
		char[] digs = "0123456789abcdef".toCharArray();
		StringBuffer digest = new StringBuffer(32);
		
		for(int i=0; i<4; i++) {
			x = regs[i];
			
			for(int j=0; j<8; j++) {
				x = leftRotate(x, 4);
				
				digest.append(digs[x & 0xf]);
			}
		}
		
		return digest.toString();
	}

	private int F(int x, int y, int z) {
		return ((x & y) | (~x & z));
	}

	private int G(int x, int y, int z) {
		return ((x & z) | (y & ~z));
	}
	
	private int H(int x, int y, int z) {
		return (x ^ y ^ z);
	}
	
	private int I(int x, int y, int z) {
		return (y ^ (x | ~z));
	}

//	private long toULong(int i) {
//		long ret = i & 0x7fffffff;
//		
//		if(i < 0)
//			ret = ret | 0x80000000;
//		
//		return ret;
//	}
	
	
	/* Let [abcd k s i] denote the operation 
	  a = b + ((a + F(b,c,d) + X[k] + T[i]) <<< s). */
	private int FF(int a, int b, int c, int d, int Xk, int s, int Ti) {
		a = a + F(b,c,d) + Xk + Ti;
		a = leftRotate(a, s);

		return (b + a);
	}
	
	/* Let [abcd k s i] denote the operation 
	  a = b + ((a + F(b,c,d) + X[k] + T[i]) <<< s). */
	private int GG(int a, int b, int c, int d, int Xk, int s, int Ti) {
		a = a + G(b,c,d) + Xk + Ti;
		a = leftRotate(a, s);

		return (b + a);
	}
	
	/* Let [abcd k s i] denote the operation 
	  a = b + ((a + F(b,c,d) + X[k] + T[i]) <<< s). */
	private int HH(int a, int b, int c, int d, int Xk, int s, int Ti) {
		a = a + H(b,c,d) + Xk + Ti;
		a = leftRotate(a, s);

		return (b + a);
	}
	
	/* Let [abcd k s i] denote the operation 
	  a = b + ((a + F(b,c,d) + X[k] + T[i]) <<< s). */
	private int II(int a, int b, int c, int d, int Xk, int s, int Ti) {
		a = a + I(b,c,d) + Xk + Ti;
		a = leftRotate(a, s);

		return (b + a);
	}

//	/* Let [abcd k s i] denote the operation 
//	  a = b + ((a + F(b,c,d) + X[k] + T[i]) <<< s). */
//	private int FF(int a, int b, int c, int d, int Xk, int s, int Ti) {
//		a = (int)(toULong(a) + toULong(F(b,c,d)) + toULong(Xk) + toULong(Ti));
//		a = leftRotate(a, s);
//
//		return (int)(toULong(b) + toULong(a));
//	}
//	
//	/* Let [abcd k s i] denote the operation 
//	  a = b + ((a + F(b,c,d) + X[k] + T[i]) <<< s). */
//	private int GG(int a, int b, int c, int d, int Xk, int s, int Ti) {
//		a = (int)(toULong(a) + toULong(G(b,c,d)) + toULong(Xk) + toULong(Ti));
//		a = leftRotate(a, s);
//
//		return (int)(toULong(b) + toULong(a));
//	}
//	
//	/* Let [abcd k s i] denote the operation 
//	  a = b + ((a + F(b,c,d) + X[k] + T[i]) <<< s). */
//	private int HH(int a, int b, int c, int d, int Xk, int s, int Ti) {
//		a = (int)(toULong(a) + toULong(H(b,c,d)) + toULong(Xk) + toULong(Ti));
//		a = leftRotate(a, s);
//
//		return (int)(toULong(b) + toULong(a));
//	}
//	
//	/* Let [abcd k s i] denote the operation 
//	  a = b + ((a + F(b,c,d) + X[k] + T[i]) <<< s). */
//	private int II(int a, int b, int c, int d, int Xk, int s, int Ti) {
//		a = (int)(toULong(a) + toULong(I(b,c,d)) + toULong(Xk) + toULong(Ti));
//		a = leftRotate(a, s);
//
//		return (int)(toULong(b) + toULong(a));
//	}
	
	
	/* Rotate 'a' for 'b' times left (mod 32 Bit) */
	private int leftRotate(int a, int b) {
		long pad;

		b = b % 32;
		pad = (long)(-Math.pow(0.5, b-32)+4294967296.0);
		
		return (int)(((a & ~pad) << b) | ((a & pad) >> (32-b)));
	}
}
